//pl0词法分析的验证程序
// 要点：
//     1 本例有2个函数：函数getch获取单个字符。 函数getsym识别保留字、变量标识符、常数、特殊符号等。
// 关键字：变量不变式、宏定义、带命名行为的函数协议
#include <stdio.h>
#include "specification.h"

//@ ghost _Bool program_incomplete, program_line_overflow;

void getch() {
     int gerror;
     int gfeof;
    if(cc==ll){
    if(feof(infile)!=0 || ferror(infile)!=0){                        // feof和ferror在stdio.h中是两个个宏定义，因此这里不是函数调用。
        printf("%s\n", "************************************");
        printf("%s\n", "      program incomplete");
        printf("%s\n", "************************************");
        //@ ghost program_incomplete = true;
        exit(1);
    }
    ll=0; cc=0;
    printf("%5ld ", cx);
    /*@ loop invariant
        (infile ->_flags & _IO_EOF_SEEN) == 0 && (infile ->_flags & _IO_ERR_SEEN) == 0 && (infile->_flags & _IO_NO_READS) == 0 
        && \length(infile) == 1 && \offset(infile) == 0 && \old(cc) == \old(ll)         // 若不使用两个命名行为的协议，则略去本行最后的\old断言。
        && cc == 0 && 0 <= ll <= 80 && (\forall long i:[1..ll].0 <= line[i] <= 255)
        ||
        ((infile ->_flags & _IO_EOF_SEEN) != 0 || (infile ->_flags & _IO_ERR_SEEN) != 0) && (infile->_flags & _IO_NO_READS) == 0         // 遇到读文件错误时
        && \length(infile) == 1 && \offset(infile) == 0 && \old(cc) == \old(ll)
        && cc == 0 && 0 < ll <= 80 && (\forall long i:[1..ll].0 <= line[i] <= 255)
        && ch==-1 && line[ll]==' '
        ;
    */
    while(feof(infile)==0 && ferror(infile)==0){                        // 这个循环的改动较大。原来要求pl0程序最后一行也必须有行结束符，现在没有这个限制。
        if(ll == 80) {                                    // 新增代码，用于检查一行代码是否超过80个字符。
            //@ ghost program_line_overflow = true;
            exit(1);
        }
        ch=getc(infile);
        if(ch != '\n' && ch != EOF){
            printf("%c",ch);
            ll=ll+1; line[ll]=ch;
        } else {
            printf("%s\n", "");
            ll=ll+1; line[ll]=' ';
            if(ch == '\n'){
                break;
            }
        }
     
    }
    }
    cc=cc+1; ch=line[cc];
}


void getsym(){
    long i,j,k;
    /*@
        lemma sorted_string_table_1: \forall integer k:[0..norw-1].
            reservedWord(word) && \string(id, al) > \string(word[k], al) ==> 
            (\forall integer n:[0..k]. \string(id, al) > \string(word[n], al));
        lemma sorted_string_table_2: \forall integer k:[0..norw-1].
            reservedWord(word) && \string(id, al) < \string(word[k], al) ==>
            (\forall integer n:[k..norw-1]. \string(id, al) < \string(word[n], al));
    */

    //@ ghost long cc_first;

    /*@loop invariant
            ch == line[cc] && currentCodeLine && \is_pstring(a, al) && (\forall integer m:[kk..al-1]. a[m] == ' ') 
            && \old(symStreamIndex) == symStreamIndex && symStreamIndex >= -1
            ;
    */
    while(ch==' ' || ch=='\t'){
        getch();
    }
    //@ ghost cc_first = cc;
    if(isalpha(ch) != 0){     // identified or reserved
        k=0;
        /*@ loop invariant
                currentCodeLine && \is_pstring(a, al) && (\forall integer m:[kk..al-1]. a[m] == ' ') && is_alpha(a[0]) && 1 <= k <= al 
                && k <= kk && (\forall integer m:[1..k-1].(is_alpha(a[m]) || is_digit(a[m]))) && \old(symStreamIndex) == symStreamIndex && symStreamIndex >= -1 
                ||
                currentCodeLine && \is_pstring(a, al) && (\forall integer m:[k..al-1].a[m]== ' ') && is_alpha(a[0]) && 1 <= k <= al 
                && k > kk && (\forall integer m:[1..k-1].(is_alpha(a[m]) || is_digit(a[m]))) && \old(symStreamIndex) == symStreamIndex && symStreamIndex >= -1;
        */
        do{
            if(k<al){
                a[k]=ch;
                k=k+1;
            }
            getch();
        }while(isalpha(ch) != 0 || isdigit(ch) != 0);
        if(k>=kk){
            kk=k;
        }else{
            /*@loop invariant
                    currentCodeLine && \is_pstring(a, al) && (\forall integer m:[kk..al-1]. a[m] == ' ') && is_alpha(a[0]) && 1 <= k < al
                    && k <= kk && (\forall integer m:[1..k-1].(is_alpha(a[m]) || is_digit(a[m]))) && \old(symStreamIndex) == symStreamIndex
                    && symStreamIndex >= -1
                    ;
            */
            do{
                kk=kk-1;
                a[kk]=' ';
            }while(k<kk);
        }
        strcpy(id, a);
        i=0;
        j=norw-1;
        /*@loop invariant
                currentCodeLine && \is_pstring(a, al) && \is_pstring(id, al) && (\forall integer m:[kk..al-1]. a[m] == ' ') 
                && \string(a, al) == \string(id, al) && 0 <= i <= norw && -1 <= j <= norw-1 && \old(symStreamIndex) == symStreamIndex
                && symStreamIndex >= -1 && (j-i >= -1 && (\forall integer n:[j+1.. norw-1]. \string(id, al) < \string(word[n], al)) 
                && (\forall integer n:[0.. i-1]. \string(id, al) > \string(word[n], al))
                ||
                j-i == -2 && k == i-1 && \string(id, al) == \string(word[k], al))
                && is_alpha(a[0]) && (\forall integer m:[0..kk-1]. (is_alpha(a[m]) || is_digit(a[m]))) && (\forall integer m:[kk..al-1]. a[m] == ' ')
                ;
        */
        while(i<=j){
            k=i+(j-i)/2;
            if(strcmp(id, word[k]) <= 0){
                j=k-1;
            }
            if(strcmp(id, word[k]) >= 0){
                i=k+1;
            }
        }
        if(i-1>j){
            sym=wsym[k];
        }else{
            sym=ident;
        }
    }else if(isdigit(ch) != 0){ // number
            k=0;
            num=0;
            sym=number;
            /*@loop invariant
                    currentCodeLine && \is_pstring(a, al) && (\forall integer m:[kk..al-1]. a[m] == ' ') && ch == line[cc] && cc < ll && ch != ' '
                    && 0 <= num < power(10, k) && 0 <= k <= nmax &&    cc_first == cc-k && sym == number && (\forall integer i:[cc_first..cc_first+k].is_digit(line[i]))
                    && 0 < cc_first < 80 &&    num == a_to_i(line, cc_first, k) && cc == cc_first + k && \old(symStreamIndex) == symStreamIndex && symStreamIndex >= -1
                    ;
            */
            while(48 <= ch && ch <= 57 && k < nmax){
                num=num*10+(ch-'0');
                k=k+1;
                getch();
                if(isdigit(ch) == 0) break;
            }
            if(k>=nmax){
                error(31);
            }
    }else if(ch==':'){
            getch();
            if(ch=='='){
                sym=becomes;
                getch();
            }else{
                sym=nul;
            }
    }else if(ch=='<'){
            getch();
            if(ch=='='){
                sym=leq;
                getch();
            }else if(ch=='>'){
                sym=neq;
                getch();
            }else{
                sym=lss;
            }
    }else if(ch=='>'){
            getch();
            if(ch=='='){
                sym=geq;
                getch();
            }else{
                sym=gtr;
            }
    }else {
            sym=ssym[(unsigned char)ch];
            getch();
    }
    /*@ 
    ghost symStreamIndex = symStreamIndex +1;
    ghost symStream[symStreamIndex] = sym;
    */
}
